#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ptrace.h>
#include <errno.h>
#include <unistd.h>

int main(int argc, char **argv)
{
	pid_t pid;
	unsigned long data;
	unsigned long addr;

	if(argc < 3) {
		fprintf(stderr, "[+] Usage: %s /usr/bin/ssh 0x08048000\n", argv[0]);
		fprintf(stderr, "[+] Would read and print out ssh's .text area\n");
		exit(EXIT_FAILURE);
	}
	
	fprintf(stderr, "[+] Forking\n");

	pid = fork();

	if(pid==0) {
		fprintf(stderr, "[+] Child's pid is %d\n", getpid());
		if(ptrace(PTRACE_TRACEME, 0, NULL, NULL)==-1) {
			fprintf(stderr, "[+] Child unable to get parent to trace it - %s\n", strerror(errno));
			exit(EXIT_FAILURE);
		}
		fflush(stderr);
		execlp(argv[1], argv[1], NULL);
		fprintf(stderr, "[+] Child unable to exec %s - %s\n", argv[1], strerror(errno));
		exit(EXIT_FAILURE);
	} 

	sleep(3);

	addr = strtoul(argv[2], NULL, 16);

	fprintf(stderr, "[+] Dumping from 0x%08x until an error occurs\n", addr);
	while((data = ptrace(PTRACE_PEEKTEXT, pid, addr, NULL)) != -1) {
		printf("%c", (char) (data) & 0xff);
		printf("%c", (char) (data >> 8) & 0xff);
		printf("%c", (char) (data >> 16) & 0xff);
		printf("%c", (char) (data >> 24) & 0xff);
		addr+=4;
	}
	fflush(stdout);
	fprintf(stderr, "\n[+] Done!@!\n");

	fprintf(stderr, "[+] Killing child\n");
	if(ptrace(PTRACE_KILL, pid, NULL, NULL)==-1) {
		fprintf(stderr, "[+] Unable to kill child\n");
		exit(EXIT_FAILURE);
	}
	fprintf(stderr, "[+] Exiting...\n");

	exit(EXIT_SUCCESS);
	
}
